/*
** Apple Macintosh Developer Technical Support
**
** File:		Start.c
** Written by:	Eric Soldan
**
** Copyright  1989-1993 Apple Computer, Inc.
** All rights reserved.
*/

/* You may incorporate this sample code into your applications without
** restriction, though the sample code has been provided "AS IS" and the
** responsibility for its operation is 100% yours.  However, what you are
** not permitted to do is to redistribute the source as "DSC Sample Code"
** after having made changes. If you're going to re-distribute the source,
** we require that you make it clear in the source that the code was
** descended from Apple Sample Code, but that you've made changes. */



/*****************************************************************************/



#include "App.h"			/* Get the application includes/typedefs, etc.	*/
#include "App.defs.h"		/* Get various application definitions.			*/
#include "App.protos.h"		/* Get the prototypes for application.			*/

#ifndef __TEXTSERVICES__
#include <TextServices.h>
#endif

#ifndef __TOOLUTILS__
#include <ToolUtils.h>
#endif



/*****************************************************************************/



OSErr		DefaultPreferences(void);

short		gQuickBalloons = (shiftKey | controlKey);
extern void _DataInit();



/*****************************************************************************/
/*****************************************************************************/

#ifdef applec
#pragma segment Main
#endif

/*****************************************************************************/
/*****************************************************************************/



void	main(void)
{

#ifdef applec
	UnloadSeg((Ptr)_DataInit);		/* Note that _DataInit can't be in Main! */
#endif

	SetApplLimit(GetApplLimit() - 16384);
		/* This decreases the application heap by 16k, which in turn
		** increases the stack by 16k. */

	MaxApplZone();					/* Expand the heap so code segments load at the top. */

	Initialize(32, kMinHeap, kMinSpace, nil, nil);	/* Initialize the program. */
	DoSetResCursor(watchCursor);					/* Rest of startup may take a while. */
	InitRequiredAppleEvents();
	InitWFMTAppleEvents();
	CLVInitialize();
	GetWindowFormats();						/* Get the window definition resource information. */
	ReadPreferences('aprf', gSignature, kPrefFileName);
	DefaultPreferences();
	OpenRuntimeOnlyAutoNewWindows();
	DoOpenApplication();
	DoAdjustMenus();
	StartDocuments();						/* Open (or print) designated documents for 6.0. */

	if(CTEUseTSMTE())
		InitTSMAwareApplication();

	UnloadSeg((Ptr)Initialize);		/* Initialize can't be in Main! */
	EventLoop();					/* Call the main event loop. */

	if(CTEUseTSMTE())
		CloseTSMAwareApplication();

	WritePreferences();
	ExitToShell();					/* Quit the application. */
}



/*****************************************************************************/



OSErr	DefaultPreferences(void)
{
	return(noErr);
}



