/*
	File:		Environment.h

	Contains:	TEnvironment is a Gestalt wrapper class that finds out information about the environment.
  				Environment.h contains the header file information for the TEnvironment class.

	Written by: Kent Sandvik	

	Copyright:	Copyright  1992-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				8/18/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				

*/
// Declare label for this header file
#ifndef _ENVIRONMENT_
#define _ENVIRONMENT_


#ifndef _DTSCPLUSLIBRARY_
#include "DTSCPlusLibrary.h"
#endif

//	Toolbox Include Files
#ifndef __GESTALTEQU__
#include <GestaltEqu.h>
#endif

#ifndef __OSUTILS__
#include <OSUtils.h>
#endif

#ifndef __TRAPS__
#include <Traps.h>
#endif


// _________________________________________________________________________________________________________ //
//	TEnvironment Class Interface

class TEnvironment
{
public:
	//	CONSTRUCTORS AND DESTRUCTORS
	TEnvironment();								// constructor
	~TEnvironment();							// destructor

	//	MAIN INTERFACE	
	virtual Boolean HasAttribute(OSType attribute,
								 short theBit);	// check for any Gestalt attribute
	virtual Boolean Check128k();				// check for MacOS version (128k Mac?)
	virtual Boolean HasAppleEvents();			// check if AE support is available
	virtual Boolean HasColorQD();				// check if Color QD is available
	virtual Boolean IsSystemSeven();			// check if we run under System 7 or not
	virtual Boolean TrapAvailable(short aNumber,
								  // check for traps
								  TrapType aType);
	// FIELDS
protected:
	Boolean fResult;							// our Gestalt result
	long fLongResult;							// used by Gestalt as well
};

#endif

// _________________________________________________________________________________________________________ //

/*	Change History (most recent last):
  No		Init.	Date		Comment
  1			khs		11/9/92		New file
*/
