/*
	File:		KeyMap.h

	Contains:	TKeyMap is a KeyMap utility class.
  				TKeyMap.h contains the header file information for the TKeyMap class construction.
 
	Written by: Kent Sandvik	

	Copyright:	Copyright  1992-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				8/18/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				

*/
// Declare label for this header file
#ifndef _KEYMAP_
#define _KEYMAP_

#ifndef _DTSCPLUSLIBRARY_
#include "DTSCPlusLibrary.h"
#endif

#ifndef __EVENTS__
#include "Events.h"
#endif

#ifndef __TOOLUTILS__
#include <ToolUtils.h>
#endif


// _________________________________________________________________________________________________________ //
//	Class Interface

class TKeyMap
// TKeyMap is a utility class for manipulation of the KeyMap information.
{
public:
	//	CONSTRUCTORS & DESTRUCTORS
	TKeyMap();
	virtual~ TKeyMap();

	//	MAIN INTERFACES
	virtual Boolean OptionKeyDown();			// test if option key is down
	virtual Boolean CommandKeyDown();			// test if command key is down
	virtual Boolean ShiftKeyDown();				// test if shift key is down
	virtual Boolean IsKeyDown(unsigned short key);// test if any key is down

	//	FIELDS
protected:
	KeyMap fKeyMap;								// caches the keymap structure
};


#endif _KEYMAP_

// _________________________________________________________________________________________________________ //


/*	Change History (most recent last):
  No			Init.		Date			Comment
  1			khs		9/20/92		New file
*/

