/*
	File:		Toolbox.h

	Contains:	TToolbox is a Toolbox utility class, used for initialization and Toolbox functions.
  				TToolbox.h contains the header file information for the Toolbox class construction.


	Written by: Kent Sandvik	

	Copyright:	Copyright  1992-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				8/18/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				

*/
// Declare label for this header file
#ifndef _TOOLBOX_
#define _TOOLBOX_

#ifndef _DTSCPLUSLIBRARY_
#include "DTSCPlusLibrary.h"
#endif


//	TOOLBOX INCLUDES
#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __QUICKDRAW__
#include <Quickdraw.h>
#endif

#ifndef __FONTS__
#include <Fonts.h>
#endif

#ifndef __WINDOWS__
#include <Windows.h>
#endif

#ifndef __MENUS__
#include <Menus.h>
#endif

#ifndef __TEXTEDIT__
#include <TextEdit.h>
#endif

#ifndef __DIALOGS__
#include <Dialogs.h>
#endif

#ifndef __EVENTS__
#include <Events.h>
#endif

#ifndef __MEMORY__
#include <Memory.h>
#endif

#ifndef __OSUTILS__
#include <OSUtils.h>
#endif

#ifndef __GESTALTEQU__
#include <GestaltEqu.h>
#endif


const short kDefaultPulls = 3;					// define how many times we want to toggle until we are frontmost app.
const short kDefaultMasterPointers = 8;			// default amount of Master pointers generated originally

// _________________________________________________________________________________________________________ //
//	Class Interface
class TToolbox
// The TToolbox class is a simple toolbox initialization class, TToolbox.Initialize
// should do most of the needed work inside an appplication when the application starts.
// TToolbox also contains environment testing code (traps, system, functions).
{
public:
	//	CONSTRUCTORS & DESTRUCTORS
	TToolbox();									// various constructors, delete if not needed
	virtual~ TToolbox();						// virtual destructor

	//	INITIATION ROUTINES							
	virtual void Initialize();					// standard initialization routine

	//	MAIN INTERFACE
	virtual void InitializeToolbox();			// initialize Toolbox
	virtual void PullApplicationToFront(short nCount = kDefaultPulls);// pull application to front
	virtual Boolean CreateMasterPointers(short nMasterPtr = kDefaultMasterPointers);// create master pointers
};


#endif

// _________________________________________________________________________________________________________ //


/*	Change History (most recent last):
  No		Init.	Date		Comment
  1			khs		6/6/92		New file
  2			khs		1/3/93		Cleanup
*/


