/*
	File:		Tracer.h

	Contains:	TTracer is an example of a stack/heap based tracing class, which could be
  				used for tracing memory leaks and keeping track of created objects
  				Tracer.h contains the header file information for the initial class construction.

	Written by: Kent Sandvik	

	Copyright:	Copyright  1992-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				8/18/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				

*/
// Declare label for this header file
#ifndef _TRACER_
#define _TRACER_

#ifndef _DTSCPLUSLIBRARY_
#include "DTSCPlusLibrary.h"
#endif

//	Toolbox Include Files
#ifndef __TYPES__
#include <Types.h>
#endif


#include <stdlib.h>

// make use of the ANSI __FILE__ and __LINE__ macros
#define TRACEPOINT __FILE__,__LINE__


// _________________________________________________________________________________________________________ //
//	Class Interface
class TTracer
{
public:
	//	CONSTRUCTORS & DESTRUCTORS
	TTracer(const char* className,
			const char* file = 0,
			int line = 0);
	virtual~ TTracer();

private:
	// FIELDS
	const char* fLabel;
	const char* fFile;
	int fLine;
	static int fReferenceCount;					// keep track of how many TTracers we construct
};


#endif

// _________________________________________________________________________________________________________ //


/*	Change History (most recent last):
  No		Init.	Date		Comment
  1			khs		7/10/92		New file
*/


