/*
	File:		SpinCursor.r

	Contains:	TSpinCursor is a simple cursor spinning class.
  				SpinCursort.r contains the  ACUR and CURS resources needed for the TSpinCursor test functions.
 				Add these resources to the test framework using something similar as:
  				Rez -rd -o TargetApplication SpinCursor.r -append

	Written by: Kent Sandvik	

	Copyright:	Copyright  1992-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				8/18/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				

*/
// INCLUDES
#include "SysTypes.r"
#include "Types.r"
#include "ApplicationResources.h"


// 'CURS' Resource (our watch (see Finder))
resource 'CURS' (6500, locked, preload) {
	$"3F00 3F00 3F00 3F00 4080 8040 8140 8260"
	$"9C60 8040 8040 4080 3F00 3F00 3F00 3F",
	$"3F00 3F00 3F00 3F00 7F80 FFC0 FFC0 FFC0"
	$"FFC0 FFC0 FFC0 7F80 3F00 3F00 3F00 3F",
	{8, 8}
};

resource 'CURS' (6501, locked, preload) {
	$"3F00 3F00 3F00 3F00 4080 8040 8040 8060"
	$"9F60 8040 8040 4080 3F00 3F00 3F00 3F",
	$"3F00 3F00 3F00 3F00 7F80 FFC0 FFC0 FFC0"
	$"FFC0 FFC0 FFC0 7F80 3F00 3F00 3F00 3F",
	{8, 8}
};

resource 'CURS' (6502, locked, preload) {
	$"3F00 3F00 3F00 3F00 4080 8040 8040 8060"
	$"9C60 8240 8040 4080 3F00 3F00 3F00 3F",
	$"3F00 3F00 3F00 3F00 7F80 FFC0 FFC0 FFC0"
	$"FFC0 FFC0 FFC0 7F80 3F00 3F00 3F00 3F",
	{8, 8}
};

resource 'CURS' (6503, locked, preload) {
	$"3F00 3F00 3F00 3F00 4080 8040 8040 8060"
	$"9C60 8440 8440 4080 3F00 3F00 3F00 3F",
	$"3F00 3F00 3F00 3F00 7F80 FFC0 FFC0 FFC0"
	$"FFC0 FFC0 FFC0 7F80 3F00 3F00 3F00 3F",
	{8, 8}
};

resource 'CURS' (6504, locked, preload) {
	$"3F00 3F00 3F00 3F00 4080 8040 8040 8060"
	$"9C60 8840 9040 4080 3F00 3F00 3F00 3F",
	$"3F00 3F00 3F00 3F00 7F80 FFC0 FFC0 FFC0"
	$"FFC0 FFC0 FFC0 7F80 3F00 3F00 3F00 3F",
	{8, 8}
};

resource 'CURS' (6505, locked, preload) {
	$"3F00 3F00 3F00 3F00 4080 8040 8040 8060"
	$"BC60 8040 8040 4080 3F00 3F00 3F00 3F",
	$"3F00 3F00 3F00 3F00 7F80 FFC0 FFC0 FFC0"
	$"FFC0 FFC0 FFC0 7F80 3F00 3F00 3F00 3F",
	{8, 8}
};

resource 'CURS' (6506, locked, preload) {
	$"3F00 3F00 3F00 3F00 4080 8040 9040 8860"
	$"9C60 8040 8040 4080 3F00 3F00 3F00 3F",
	$"3F00 3F00 3F00 3F00 7F80 FFC0 FFC0 FFC0"
	$"FFC0 FFC0 FFC0 7F80 3F00 3F00 3F00 3F",
	{8, 8}
};


// The main 'acur', defined as the kWatchID constant in the program.
resource 'acur' (6500, locked, preload) {
	{	/* array CursIdArray: 8 elements */
		/* [1] */
		4,
		/* [2] */
		6500,
		/* [3] */
		6501,
		/* [4] */
		6502,
		/* [5] */
		6503,
		/* [6] */
		6504,
		/* [7] */
		6505,
		/* [8] */
		6506
	}
};


// _________________________________________________________________________________________________________ //

/*	Change History (most recent last):
  No		Init.	Date		Comment
  1			khs		12/14/92	New file
  2			khs		1/3/93		Cleanup
*/
