/*
	File:		GDeviceTest.cp

	Contains:	TGDevice is a GDevice utility class, finding out GDevice information.
  				GDeviceTest.cp contains the class testing functions.

	Written by: Kent Sandvik	

	Copyright:	Copyright  1992-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				8/18/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				

*/
#ifndef _GDEVICE_
#include "GDevice.h"
#endif

// This test will scan through all the GDevices on the system, and print
// out the base address, row, and the depth size.

void main(void)
{
	Ptr aBase;
	long aRow;
	short aDepth;

	cout << "TGDevice test \n";

	// Iterate through all the screens connected to the system.
	for (TGDevice myScreens; !myScreens.Last(); myScreens.Next())
	{
		aBase = myScreens.GetBase();
		aRow = myScreens.GetRow();
		aDepth = myScreens.GetDepth();

		printf("Base address = %X\n", aBase);
		fflush(stdout);							// cout was broken (MPW) concerning %X
		cout << "Row = " << aRow;
		cout << "\n";
		cout << "Depth = " << aDepth;
		cout << "\n";
	}
}

// _________________________________________________________________________________________________________ //


/*	Change History (most recent last):
  No		Init.	Date		Comment
  1			khs		6/2/92		New file
  2			khs		7/5/92		First decent release
  3			khs		9/7/92		Changed the structure of the classes
*/


