/*
	File:		TimerTest.cp

	Contains:	TTimer is a simple timing class that could provide both 10 lap time values as well as
  				final values.
  				TTimerTest.cp contains the TTimer test functions.
  
	Written by: Kent Sandvik	

	Copyright:	Copyright  1992-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				8/18/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				

*/
#ifndef _TIMER_
#include "Timer.h"
#endif

// This simple test is testing out the TTimer class, taking lap values as well
// as final values.

const kSecond = 60;								// definition of a second


void main(void)
{
	cout << "Start of TTimer test\n";

	// create a TTimer class
	TTimer myTimer;

	myTimer.Start();
	Delay(kSecond * 1, NULL);					// 1 second delay
	printf("Get Lap time = %i ticks\n",myTimer.GetLap());

	myTimer.SetLap(3);							// set the third lap counter	
	Delay(kSecond * 2, NULL);
	myTimer.Stop();								// 2 second delay

	printf("Time between start and stop = %i ticks\n",myTimer.GetTicks());
	printf("Or in seconds = %is\n",myTimer.GetSeconds());
	printf("Lap counter 3 is = %i ticks\n",myTimer.GetLap(3));

	cout << "End of the TTimer test!\n";
}


// _________________________________________________________________________________________________________ //


/*	Change History (most recent last):
  No		Init.	Date		Comment
  1			khs		12/14/92	New file
  2			khs		1/3/93		Cleanup
*/
