/*
	File:		MailableWindow.h

	Contains:	An abstract class for AOCE-mailable windows

	Written by: Dave Falkenburg	

	Copyright:	Copyright  1993-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				8/19/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				8/26/94		DRF				Added AdjustPerfectWindowSizeForMailer.

*/
#ifndef	_MAILABLEWINDOW_
#define	_MAILABLEWINDOW_

#include "Window.h"


#define	kCanContract			true
#define	kInitiallyExpanded		true
#define	kDefaultAuthIdentity	((AuthIdentity) 0)


class	TMailableWindow : public TWindow
	{
public:
						TMailableWindow();
	virtual				~TMailableWindow();

	//	Overriden methods of TWindow
	
	virtual	Boolean		EventFilter(EventRecord * theEvent);
	virtual void		CreateWindow(WindowType typeOfWindowToCreate = kNormalWindow);
	virtual	void		Draw(void);
	virtual void		AdjustForNewWindowSize(Rect * oldRect,Rect * newRect);
	virtual	Boolean		Close(void);

	//	AOCE-specific methods
	
	virtual OSErr		AttachMailerToWindow(Boolean createExpanded);
	virtual OSErr		RemoveMailerFromWindow(void);

	virtual void		ExpandOrContractMailer(Boolean doExpand);
	
	virtual void		AdjustPerfectWindowSizeForMailer(Rect * perfectSize);

	virtual void		AdjustForNewContentRect(Rect * prevContentRect,Rect * newContentRect);
	virtual void		DrawContents(void);
	
protected:
	Boolean				fMailerIsAttached;
	Boolean				fMailerIsExpanded;

	Rect				fContentRect;

	//	AOCE-related data structures in here
	};

pascal	WindowPtr	FrontWindowProcForAOCE(long /* unusedParam */);


#endif