/*
	File:		AppleEventHandling.h

	Contains:	Minimalist support for the required and Display Manager suites
				To really support AppleScript, well do more work in here.

	Written by: Dave Falkenburg	

	Copyright:	Copyright  1993-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				8/19/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				12/15/94	DRF				Added ChooseApplicationAsAEtarget.
				11/23/94	DRF				InstallAppleEventHandlers is now called InitAppleEventRoutines.
											Also added a useful global: gThisProcessDesc for self targetting
											of AppleEvents.
				11/16/94	DRF				Add StandardAEIdleProc for people who like using AESend with
											kAEWaitReply.
				11/12/94	DRF				AppConditionals.h -> BuildConditionals.h
				9/4/94		DRF				Added Text Services AppleEvent handlers.

*/
#ifndef		_APPLEEVENTHANDLING_
#define		_APPLEEVENTHANDLING_

#ifndef		__APPLEEVENTS__
#include	<AppleEvents.h>
#endif

#ifndef		__OCESTANDARDMAIL__
#include	<OCEStandardMail.h>
#endif


void				InitAppleEventRoutines(void);
OSErr				CheckAppleEventForMissingParams(AppleEvent * theAppleEvent);
OSErr				ChooseApplicationAsAETarget(AEAddressDesc *targetDesc, StringPtr prompt);

extern AEIdleUPP	StandardAEIdleUPP;
extern AEDesc		gThisProcessDesc;

//	Handlers for the Required Suite:

typedef OSErr		(*EachDocumentProcPtr)(LetterDescriptor *aFile,void * param);
OSErr				ForEachDocumentInList(AEDescList documentList,EachDocumentProcPtr documentProc,void * documentParam);

pascal OSErr		HandleOpenApplication(AppleEvent * theAppleEvent,AppleEvent * reply, long refCon);
pascal OSErr		HandleOpenDocuments(AppleEvent * theAppleEvent,AppleEvent * reply, long refCon);
pascal OSErr		HandlePrintDocuments(AppleEvent * theAppleEvent,AppleEvent * reply, long refCon);
pascal OSErr		HandleQuitApplication(AppleEvent * theAppleEvent,AppleEvent * reply, long refCon);


//	Display Manager:

pascal OSErr	HandleSystemConfigNotice(AppleEvent *theAppleEvent,AppleEvent *reply,long refCon);


#if	qInlineInputAware

//	Text Services Manager:

pascal OSErr	HandleTextServicesUpdateActiveInputArea(AppleEvent *theAppleEvent,AppleEvent *reply,long refCon);
pascal OSErr	HandleTextServicesPos2Offset(AppleEvent *theAppleEvent,AppleEvent *reply,long refCon);
pascal OSErr	HandleTextServicesOffset2Pos(AppleEvent *theAppleEvent,AppleEvent *reply,long refCon);

#endif

#endif
