/*
	File:		DocWindow.h

	Contains:	A simple document window

	Written by: Dave Falkenburg	

	Copyright:	Copyright  1993-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				8/19/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				9/4/94		DRF				Added scroll bars and revised dragging methods.

*/

#ifndef		_DOCWINDOW_
#define		_DOCWINDOW_

#ifndef		_WINDOW_
#include	"Window.h"
#endif

#ifndef		__THREADS__
#include	<Threads.h>
#endif

class	TDocWindow	:	public TWindow
	{
public:
							TDocWindow();
	virtual 				~TDocWindow();

	virtual WindowPtr		MakeNewWindow(WindowPtr behindWindow);

	virtual	void			AdjustCursor(EventRecord * anEvent);

	virtual void			Activate(Boolean activating);
	virtual void			Draw(void);
	virtual void			Click(EventRecord * anEvent);

	virtual void			AdjustForNewWindowSize(Rect * oldRect,Rect * newRect);

	virtual	Boolean			Close(void);
	
	virtual	OSErr			DragEnterWindow(DragReference theDrag);
	virtual	OSErr			DragInWindow(DragReference theDrag);
	virtual	OSErr			DragLeaveWindow(DragReference theDrag);
	virtual	OSErr			HandleDrop(DragReference theDrag);

//	new methods

	virtual	void			DoControlAction(ControlHandle whichControl,short whichPart);
	virtual void			SpinHeaderArrows();

protected:
	static	unsigned long	fgUntitledTagCount;

	ControlHandle			fVerticalScroll,fHorizontalScroll;
	Boolean					fVerticalScrollActive,fHorizontalScrollActive;

	ThreadID				fSpinnerThreadID;
	short					fCurrentSpinningArrowIconID;

	RgnHandle				fDragTargetRgn;
	Boolean					fCanAcceptDrag;
	};

#endif
