/*
	File:		Preferences.h

	Contains:	Application-specific preferences format.

	Written by: Dave Falkenburg	

	Copyright:	Copyright  1993-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				8/19/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				

*/

#ifndef	_PREFERENCES_
#define	_PREFERENCES_

#define	kCurrentPrefsTag		'drf '
#define	kCurrentPrefsVersion	0

#define	kPrefResType			'pref'
#define	kPrefsResID				0


#ifndef	__OCESTANDARDMAIL__
#include <OCEStandardMail.h>
#endif

//	AOCE-specific preferences.
//	TMailableWindow makes use of this structure, and it must be accessible
//	via gPreferences.fMailPreferences

typedef struct MailPreferences	MailPreferences;
struct MailPreferences
	{
	SMPCloseOptions fSMPCloseOptions;
	SMPSendOptions	fSMPSendOptions;
	SMPSendFormat	fSMPSendFormat;
	Boolean			fCreateMailerForNewDocuments;
	Boolean			fExpandMailerForNewLetter;
	Boolean			fExpandMailerForOpenedLetter;
	Boolean			fUseCloseOptionsDialog;
	Boolean			fCloseLetterAfterSend;
	};


//	Application specific preferences structure.
//	NOTE: gPreferences.fMailPreferences is required to exist if MailableWindows are used

typedef struct AppPreferences	AppPreferences;
struct AppPreferences
	{
	OSType				fPreferencesTag;
	unsigned long		fPreferencesVersion;
	
	MailPreferences		fMailPreferences;		//	required if MailableWindow is used
	};

extern AppPreferences	gPreferences;

#endif
