/*
	File:		MoreAppleEvents.h

	Contains:	

	Written by:	Pete Gontier

	Copyright:	Copyright (c) 1998 Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):

         <4>     2/15/99    PCG     add AEGetDescDataSize for non-Carbon clients
         <3>     1/29/99    PCG     add AEGetDescData
         <2>    11/11/98    PCG     fix headers
         <1>    11/10/98    PCG     first big re-org at behest of Quinn

	Old Change History (most recent first):

         <4>    10/11/98    Quinn   Convert "MorePrefix.h" to "MoreSetup.h".
         <3>      9/9/98    PCG     re-work import and export pragmas
         <2>     7/24/98    PCG	    coddle linker (C++, CFM-68K)
         <1>     6/16/98    PCG     initial checkin
*/

#pragma once

#include "MoreSetup.h"

#include <AppleEvents.h>
#include <Processes.h>

#ifdef __cplusplus
	extern "C" {
#endif

#pragma import on // for clients
#pragma export on // for building a library

pascal OSErr	SenderIsFinder			(const AppleEvent *, Boolean *);
pascal OSErr	SetReplyErrorNumber		(OSErr errToReport, AppleEvent *);
pascal OSErr	CreateProcessTarget		(ProcessSerialNumber *, AEDesc *);
pascal OSErr	CreateSimpleAppleEvent	(AEEventClass, AEEventID, ProcessSerialNumber *, AppleEvent *);
pascal OSErr	SimplySendAppleEvent	(const AppleEvent *, AppleEvent *);

#if !TARGET_CARBON

pascal Size		AEGetDescDataSize		(const AEDesc *);
pascal OSErr	AEGetDescData			(const AEDesc *, DescType, void *, Size);

#endif

#pragma import reset // for clients
#pragma export reset // for building a library

#ifdef __cplusplus
	}
#endif
