/*
	File:		TestMoreMemory.h

	Contains:	Simple test program for the MoreMemory library.

	Written by:	Quinn

	Copyright:	Copyright  1999 by Apple Computer, Inc., all rights reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):

         <1>      1/3/99    Quinn   First checked in.
*/

/////////////////////////////////////////////////////////////////

// MoreIsBetter Setup

#include "MoreSetup.h"

// Standard Mac OS interfaces

#include <MacTypes.h>

// Standard C interfaces

#include <stdio.h>

// MIB Prototypes

#include "MoreMemory.h"

/////////////////////////////////////////////////////////////////

static UInt16 gBuffer[16];

void main(void)
{
	OSStatus err;
	
	printf("Hello Cruel World!\n");
	printf("TestMoreMemory\n");
	printf("-- A simple test program for the MoreMemory library.\n");
	
	Debugger();
	err = SafeHoldMemory(gBuffer, sizeof(gBuffer));
	if (err == noErr) {
		err = SafeUnholdMemory(gBuffer, sizeof(gBuffer));
	}
		
	if (err == noErr) {
		printf("Success!\n");
	} else {
		printf("Failed with error %ld.\n", err);
	}
}
