/*
	File:		MenuKeyGlyphs.h

	Contains:	

	Written by:	Pete Gontier

	Copyright:	Copyright  1998 Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):

         <2>    11/11/98    PCG     fix header
         <1>    11/11/98    PCG     re-org at behest of Quinn

	Old Change History (most recent first):

         <1>     6/16/98    PCG     initial checkin
*/

#pragma once

/*************************************************************************
**
**	Menu Key Glyph Constants
**
**	Apple Macintosh Developer Technical Support
**
**	revision history
**	----------------------------
**	MXM		??/??/97	created
**	PCG		02/09/98	assimilated
**
**	writers
**	----------------------------
**	MXM		Matthew Xavier Mora
**	PCG		Pete Gontier
**
**************************************************************************/

enum
{
	MoreMenus_kKeyGlyphNull						= 0x00, // Null(always glyph 1)
	MoreMenus_kKeyGlyphUnassigned				= 0x01,	// (reserved for 2 bytes)
	MoreMenus_kKeyGlyphLeftToRightTabKey		= 0x02,
	MoreMenus_kKeyGlyphRightToLeftTabKey		= 0x03,
	MoreMenus_kKeyGlyphEnterKey					= 0x04,
	MoreMenus_kKeyGlyphShiftKey					= 0x05,
	MoreMenus_kKeyGlyphControlKey				= 0x06,
	MoreMenus_kKeyGlyphOptionKey				= 0x07,
	MoreMenus_kKeyGlyphNull1					= 0x08,
	MoreMenus_kKeyGlyphSpaceKey					= 0x09,
	MoreMenus_kKeyGlyphDeleteKey				= 0x0A,
	MoreMenus_kKeyGlyphLeftToRightReturnKey		= 0x0B,
	MoreMenus_kKeyGlyphRightToLeftReturnKey		= 0x0C,
	MoreMenus_kKeyGlyphNonmarkingReturnKey		= 0x0D,
	MoreMenus_kKeyGlyphUnassigned1				= 0x0E,
	MoreMenus_kKeyGlyphPencilKey				= 0x0F,
	MoreMenus_kKeyGlyphDownwardDashedArrowKey	= 0x10,
	MoreMenus_kKeyGlyphCommandKey				= 0x11,
	MoreMenus_kKeyGlyphCheckmarkKey				= 0x12,
	MoreMenus_kKeyGlyphDiamondKey				= 0x13,
	MoreMenus_kKeyGlyphAppleLogoKey				= 0x14,
	MoreMenus_kKeyGlyphUnassigned2				= 0x15,	// (paragraph in Korean)
	MoreMenus_kKeyGlyphUnassigned3				= 0x16,
	MoreMenus_kKeyGlyphForwardDelete			= 0x17,
	MoreMenus_kKeyGlyphLeftwardDashedArrowKey	= 0x18,
	MoreMenus_kKeyGlyphUpwardDashedArrowKey		= 0x19,
	MoreMenus_kKeyGlyphRightwardDashedArrowKey	= 0x1A,
	MoreMenus_kKeyGlyphEscapeKey				= 0x1B,
	MoreMenus_kKeyGlyphClearKey					= 0x1C,
	MoreMenus_kKeyGlyphUnassigned4				= 0x1D, // (left double quotes in Japanese)
	MoreMenus_kKeyGlyphUnassigned5				= 0x1E, // (right double quotes in Japanese)
	MoreMenus_kKeyGlyphUnassigned6				= 0x1F, // (trademark in Japanese)
	MoreMenus_kKeyGlyphBlankKey					= 0x61,
	MoreMenus_kKeyGlyphPageUpKey				= 0x62,
	MoreMenus_kKeyGlyphCapsLockKey				= 0x63,
	MoreMenus_kKeyGlyphLeftArrowKey				= 0x64,
	MoreMenus_kKeyGlyphRightArrowKey			= 0x65,
	MoreMenus_kKeyGlyphNorthwestArrowKey		= 0x66,
	MoreMenus_kKeyGlyphHelpKey					= 0x67,
	MoreMenus_kKeyGlyphUpArrowKey				= 0x68,
	MoreMenus_kKeyGlyphSouthEastArrowKey		= 0x69,
	MoreMenus_kKeyGlyphDownArrowKey				= 0x6A,
	MoreMenus_kKeyGlyphPageDownKey				= 0x6B,
	MoreMenus_kKeyGlyphAppleLogoKeyOutline		= 0x6C,
	MoreMenus_kKeyGlyphContextualMenuKey		= 0x6D,
	MoreMenus_kKeyGlyphPowerKey					= 0x6E,
	MoreMenus_kKeyGlyphF1Key					= 0x6F,
	MoreMenus_kKeyGlyphF2Key					= 0x70,
	MoreMenus_kKeyGlyphF3Key					= 0x71,
	MoreMenus_kKeyGlyphF4Key					= 0x72,
	MoreMenus_kKeyGlyphF5Key					= 0x73,
	MoreMenus_kKeyGlyphF6Key					= 0x74,
	MoreMenus_kKeyGlyphF7Key					= 0x75,
	MoreMenus_kKeyGlyphF8Key					= 0x76,
	MoreMenus_kKeyGlyphF9Key					= 0x77,
	MoreMenus_kKeyGlyphF10Key					= 0x78,
	MoreMenus_kKeyGlyphF11Key					= 0x79,
	MoreMenus_kKeyGlyphF12Key					= 0x7A,
	MoreMenus_kKeyGlyphF13Key					= 0x87,
	MoreMenus_kKeyGlyphF14Key					= 0x88,
	MoreMenus_kKeyGlyphF15Key					= 0x89,
	MoreMenus_kKeyGlyphControlKey1				= 0x8A  // (ISO standard)
};

