/*
	File:		MoreOpenAndSave.h

	Contains:	

	Written by:	Pete Gontier

	Copyright:	Copyright (c) 1998 Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):

         <4>     1/22/99    PCG     TARGET_CARBON
         <3>      1/7/99    PCG     fix indentation, EnableDisableNav, WillUseNav,
                                    GetFirstCustomItemIndex
         <2>    11/11/98    PCG     fix headers
         <1>    11/10/98    PCG     first big re-org at behest of Quinn

	Old Change History (most recent first):

         <5>    10/11/98    Quinn   Convert "MorePrefix.h" to "MoreSetup.h".
         <4>      9/9/98    PCG     re-work import and export pragmas
         <3>     7/24/98    PCG	    coddle linker (C++, CFM-68K)
         <2>     7/11/98    PCG     add header
*/

#pragma once

#include "MoreSetup.h"
#include <StandardFile.h>

#ifdef __cplusplus
	extern "C" {
#endif

#pragma import on // for clients
#pragma export on // for building a library

#if !TARGET_CARBON

	pascal Boolean
MOASI_EnableDisableNav
	(Boolean);

#endif

	pascal Boolean
MOASI_WillUseNav
	(void);

	pascal DialogItemIndexZeroBased
MOASI_GetFirstCustomItemIndex
	(void);

	pascal OSErr
MOASI_CustomPutFile
	(	volatile	ConstStr255Param						prompt,				// same as CustomPutFile
		volatile	ConstStr255Param						defaultName,		// same as CustomPutFile
					StandardFileReply *			volatile,						// same as CustomPutFile
		volatile	short									ditlResID,			// 'DITL' resource ID to APPEND to the existing dialog
		volatile	DlgHookYDUPP,												// slightly different from CustomGetFile
		volatile	ModalFilterYDUPP,											// slightly different
					void *						volatile	yourDataPtr		);	// same as CustomPutFile

	pascal OSErr
MOASI_CustomGetFile
	(	volatile	FileFilterYDUPP,											// same as CustomGetFile
		volatile	short									numTypes,			// same as CustomGetFile
		volatile	ConstSFTypeListPtr,											// same as CustomGetFile
					StandardFileReply *			volatile,						// same as CustomGetFile
		volatile	short									ditlResID,			// 'DITL' resource ID to APPEND to the existing dialog
		volatile	DlgHookYDUPP,												// slightly different from CustomGetFile
		volatile	ModalFilterYDUPP,											// slightly different from CustomGetFile
					void *						volatile	yourDataPtr		);	// same as CustomGetFile

	pascal OSErr
MOASI_StandardGetFile
	(	volatile	FileFilterUPP,												// same as StandardGetFile
		volatile	short									numTypes,			// same as StandardGetFile
		volatile	ConstSFTypeListPtr,											// same as StandardGetFile
					StandardFileReply *		volatile						);	// same as StandardGetFile

	pascal OSErr
MOASI_StandardPutFile
	(	volatile	ConstStr255Param						prompt,				// same as StandardPutFile
		volatile	ConstStr255Param						defaultName,		// same as StandardPutFile
					StandardFileReply *		volatile						);	// same as StandardPutFile

	pascal OSErr
MOASI_StandardOpenDialog
	(				StandardFileReply *		volatile						);	// same as StandardOpenDialog

	pascal OSErr
MOASI_StandardGetFilePreview
	(	volatile	FileFilterUPP,												// same as MOASI_StandardGetFile
		volatile	short									numTypes,			// same as MOASI_StandardGetFile
		volatile	ConstSFTypeListPtr,											// same as MOASI_StandardGetFile
					StandardFileReply *		volatile						);	// same as MOASI_StandardGetFile

	pascal OSErr
MOASI_CustomGetFilePreview
	(	volatile	FileFilterYDUPP,											// same as MOASI_CustomGetFile
		volatile	short									numTypes,			// same as MOASI_CustomGetFile
		volatile	ConstSFTypeListPtr,											// same as MOASI_CustomGetFile
					StandardFileReply *			volatile,						// same as MOASI_CustomGetFile
		volatile	short									ditlResID,			// same as MOASI_CustomGetFile
		volatile	DlgHookYDUPP,												// same as MOASI_CustomGetFile
		volatile	ModalFilterYDUPP,											// same as MOASI_CustomGetFile
					void *						volatile	yourDataPtr		);	// same as MOASI_CustomGetFile

#pragma import reset // for clients
#pragma export reset // for building a library

#ifdef __cplusplus
	}
#endif
