/*
	File:		MorePreferences.h

	Contains:	

	Written by:	Pete Gontier

	Copyright:	Copyright (c) 1998 Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):

         <3>     1/22/99    PCG     dunno
         <2>    11/11/98    PCG     fix headers
         <1>    11/10/98    PCG     first big re-org at behest of Quinn

	Old Change History (most recent first):

         <6>    10/11/98    Quinn   Convert "MorePrefix.h" to "MoreSetup.h".
         <5>     11/9/98    PCG     fix comment 4
         <4>     11/9/98    PCG     add copyright blurb and OpenPrefsResourceFile
         <3>      9/9/98    PCG     re-work import and export pragmas
         <2>     7/24/98    PCG	    coddle linker (C++, CFM-68K)
         <1>     6/16/98    PCG     initial checkin
*/

#pragma once

#include "MoreSetup.h"
#include <Files.h>

enum
{
	kPrefsReservedType		= 'prrt',
	kPrefsFileType			= 'pref'
};

typedef FourCharCode	PrefsType;
typedef UInt32			PrefsID;

typedef struct OpaquePrefsCollection *PrefsCollection;

#ifdef __cplusplus
	extern "C" {
#endif

#pragma import on // for clients
#pragma export on // for building a library

pascal OSErr GetPrefsFileCreator			(OSType *);
pascal OSErr SetPrefsFileCreator			(OSType);
pascal OSErr SetPrefsFolderName				(ConstStr255Param folderName);
pascal OSErr GetPreferenceSize				(PrefsCollection, PrefsType, PrefsID, Size *);
pascal OSErr GetPreference					(PrefsCollection, PrefsType, PrefsID, Size, Size *actualSize, void *);
pascal OSErr SetPreference					(PrefsCollection, PrefsType, PrefsID, Size, void *);
pascal OSErr NewPrefsCollection				(PrefsCollection *);
pascal OSErr DisposePrefsCollection			(PrefsCollection);
pascal OSErr GetNewPrefsCollection			(PrefsCollection *, ConstStr255Param fileName);
pascal OSErr WritePrefsCollection			(PrefsCollection, ConstStr255Param fileName);
pascal OSErr GetNewPrefsCollectionFromFile	(PrefsCollection *, const FSSpec *);
pascal OSErr WritePrefsCollectionToFile		(PrefsCollection, const FSSpec *);
pascal OSErr PrefsAreSame					(PrefsCollection, PrefsCollection, Boolean *);

#pragma import reset // for clients
#pragma export reset // for building a library

#ifdef __cplusplus
	}
#endif
