/*
	File:		MoreSound.h

	Contains:	

	Written by:	Pete Gontier

	Copyright:	Copyright (c) 1998 Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):

         <2>    11/11/98    PCG     fix headers
         <1>    11/10/98    PCG     first big re-org at behest of Quinn

	Old Change History (most recent first):

         <2>    10/11/98    Quinn   Convert "MorePrefix.h" to "MoreSetup.h".
         <1>    10/23/98    PCG     initial check-in
*/

#pragma once

#include "MoreSetup.h"

#include <Sound.h>

#ifdef __cplusplus
	extern "C" {
#endif

#pragma import on // for clients
#pragma export on // for building a library

pascal OSErr NewDigitizedSoundChannel	(UInt16 qLength, SndChannelPtr *);
pascal OSErr DisposeSoundChannel		(SndChannelPtr);
pascal OSErr PlaySoundListHandle		(SndChannelPtr, SndListHandle, Boolean asynch);
pascal OSErr IsSoundChannelPlaying		(SndChannelPtr, Boolean *isPlaying);

#pragma import reset // for clients
#pragma export reset // for building a library

#ifdef __cplusplus
	}
#endif
