/*
	File:		MoreWindows.h

	Contains:	

	Written by:	Pete Gontier

	Copyright:	Copyright (c) 1998 Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):

         <4>     1/25/99    PCG     TARGET_CARBON
         <3>    11/11/98    PCG     fix headers
         <2>    11/11/98    PCG     fix header
         <1>    11/10/98    PCG     first big re-org at behest of Quinn

	Old Change History (most recent first):

         <4>    10/11/98    Quinn   Convert "MorePrefix.h" to "MoreSetup.h".
         <3>      9/9/98    PCG     re-work import and export pragmas
         <2>     7/24/98    PCG	    coddle linker (C++, CFM-68K)
         <1>     6/16/98    PCG     initial checkin
*/

#pragma once

#include "MoreSetup.h"

#include <MacWindows.h>

#ifdef __cplusplus
	extern "C" {
#endif

#pragma import on // for clients
#pragma export on // for building a library

pascal OSStatus		MoveWindowToAlertPosition	(WindowRef);

pascal OSErr		MoreNewWindow				(	const Rect *			boundsRect,
													ConstStr255Param 		title,
													short 					theProc,
													Boolean 				goAwayFlag,
													long 					refCon,
													WindowRef				*window				);

#pragma import reset // for clients
#pragma export reset // for building a library

#ifdef __cplusplus
	}
#endif


#if !TARGET_CARBON
#	define GetWindowPortBounds(x,r)		do { *(r) = (x)->portRect; } while (false)
#endif
