(*
	File:		MoreSetup.p

	Contains:	Standard unit for MoreIsBetter Pascal code.

	Written by:	Quinn

	Copyright:	Copyright  1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):

         <1>     25/2/99    ???     First checked in.
*)

unit MoreSetup;

interface

(*
	//	Almost every non-trivial module needs to detect
	//	or produce errors, so we include it for the
	//	convenience of all modules.
*)

	uses
		Errors;

(*
	//	Our assertion macros compile down to nothing if
	//	MORE_DEBUG is not true.  MoreAssertQ is Quinn's flavor
	//	of MoreAssert which does not produce a value.
	//	MoreAssert is not available to Pascal because
	//	it's hard to define it properly.
*)

{$ifc MORE_DEBUG}
	{$definec MoreAssertQ(mustBeTrue) begin if not (mustBeTrue) then DebugStr('MoreAssert failure') end}
{$elsec}
	{$definec MoreAssertQ(mustBeTrue) }
{$endc}

implementation

end. (* MoreSetup *)

