#
#	Apple Macintosh Developer Technical Support
#
#	MultiFinder-Aware Simple TextEdit Sample Application
#
#	OOPTESample
#
#	OOPTESample.make	- MPW Make Facility Source
#
#	Copyright  1988, 1989 Apple Computer, Inc.
#	All rights reserved.
#
#	Versions:		
#					1.00					04/89
#					1.10					02/90
#					1.11					10/92
#
#	Components:     
#					BuildOOPTESample			February 1, 1990
#					MTESample.p					February 1, 1990
#					OOPTESample.make			February 1, 1990
#					TECommon.h					February 1, 1990
#					TESampleGlue.a				February 1, 1990
#					TESample.r					February 1, 1990
#					TMLRules.make				February 1, 1990
#					UApplication.p				February 1, 1990
#					UApplication.inc1.p			February 1, 1990
#					UDocument.p					February 1, 1990
#					UDocument.inc1.p			February 1, 1990
#					UTEDocument.p				February 1, 1990
#					UTEDocument.inc1.p			February 1, 1990
#					UTESample.p					February 1, 1990
#					UTESample.inc1.p			February 1, 1990
#

# NOTE: This make script should be called from 'BuildOOPTESample'. It depends
# on some variables declared there.

kSignature = 'MOOT'

# turn off SADE symbols. To turn symbols on, add '-sym on' after the
# equals sign. DON'T use '-sym off' if you want to use TML Pascal; it
# doesn't recognize it.
SymOpts =

# Pascal options
PasOpts = {SymOpts}

# Linker optins
LinkOpts = {SymOpts}

Objs =	
	"{ObjFolder}"UApplication.p.o 
	"{ObjFolder}"UDocument.p.o 
	"{ObjFolder}"UTEDocument.p.o 
	"{ObjFolder}"UTESample.p.o 
	"{ObjFolder}"TESampleGlue.a.o 
	"{ObjFolder}"MTESample.p.o

Srcs =	
	UApplication.p 
	UDocument.p 
	UTEDocument.p 
	UTESample.p 
	TESampleGlue.a 
	MTESample.p
	
RezFile = TESample.r

SysLibs = 	"{Libraries}"Runtime.o 
			"{Libraries}"Interface.o 
			"{Libraries}"ObjLib.o 
			"{PasLib}"

	
"{ObjFolder}"MTESample.p.o		 
		{Srcs}

"{ObjFolder}"UDocument.p.o		 
		UDocument.inc1.p

"{ObjFolder}"UApplication.p.o	 
		UApplication.inc1.p 
		UDocument.p

"{ObjFolder}"UTEDocument.p.o	 
		UTEDocument.inc1.p 
		UApplication.p 
		UDocument.p

"{ObjFolder}"UTESample.p.o		 
		UTESample.inc1.p 
		UApplication.p 
		UDocument.p 
		UTEDocument.p

# Everything below here is pretty generic, and shouldn't
# have to be modified. You can customize it by changing the
# variables above.

.p.o	 .p
	Echo "Compiling:     {Default}.p"
	{Pascal} {PasOpts} 
		-o {targDir}{default}.p.o 
		{depDir}{default}.p

.a.o	 .a
	Echo "Assembling:    {Default}.a"
	Asm -o {targDir}{default}.a.o 
		{depDir}{default}.a

"{ObjFolder}"	 :

{AppName}  {Objs} {AppName}.make
	Echo "Linking:       {AppName}"
	Link -o {Targ} {LinkOpts} {Objs} {SysLibs} 
	SetFile {Targ} -t APPL -c kSignature -a B

{AppName}  {RezFile} {AppName}.make
	Echo "Rezzing:       {RezFile}"
	Rez -append -o {Targ} {RezFile}

