{---------------------------------------------------------------------
#
#	Apple Macintosh Developer Technical Support
#
#	MultiFinder-Aware Simple TextEdit Sample Application
#
#	OOPTESample
#
#	UTEDocument.p		-	Pascal Source
#
#	Copyright  1988, 1989 Apple Computer, Inc.
#	All rights reserved.
#
#	Versions:		
#					1.00					04/89
#					1.10					02/90
#					1.11					10/92
#
#	Components:     
#					BuildOOPTESample			February 1, 1990
#					MTESample.p					February 1, 1990
#					OOPTESample.make			February 1, 1990
#					TECommon.h					February 1, 1990
#					TESampleGlue.a				February 1, 1990
#					TESample.r					February 1, 1990
#					TMLRules.make				February 1, 1990
#					UApplication.p				February 1, 1990
#					UApplication.inc1.p			February 1, 1990
#					UDocument.p					February 1, 1990
#					UDocument.inc1.p			February 1, 1990
#					UTEDocument.p				February 1, 1990
#					UTEDocument.inc1.p			February 1, 1990
#					UTESample.p					February 1, 1990
#					UTESample.inc1.p			February 1, 1990
#
---------------------------------------------------------------------}

UNIT UTEDocument;

INTERFACE

USES
	Types, QuickDraw, Controls, Events, Windows, TextEdit, Dialogs,
	Menus, Devices, ToolUtils, OSUtils, Scrap, Memory,
	ObjIntf, UDocument, UApplication;

PROCEDURE PascalClickLoop;
FUNCTION GetOldClickLoop:TEClickLoopUPP;

TYPE
	TTEDocument = OBJECT(TDocument)
		fDocTE:			TEHandle;		{ Our text, who art in heaven... }
		fDocVScroll:	ControlHandle;	{ Vertical Scrollbar }
		fDocHScroll:	ControlHandle;	{ Horizontal Scrollbar }
		fDocClick:		TEClickLoopUPP;	{ Our click loop }

		PROCEDURE TTEDocument.ITEDocument(resID:integer);
		PROCEDURE TTEDocument.Free; OVERRIDE;

		{ methods from TDocument we override }
		PROCEDURE TTEDocument.DoZoom(partCode:integer); OVERRIDE;
		PROCEDURE TTEDocument.DoGrow(theEvent:EventRecord); OVERRIDE;
		PROCEDURE TTEDocument.DoContent(theEvent:EventRecord); OVERRIDE;
		PROCEDURE TTEDocument.DoKeyDown(theEvent:EventRecord); OVERRIDE;
		PROCEDURE TTEDocument.DoActivate(becomingActive:Boolean); OVERRIDE;
		PROCEDURE TTEDocument.DoIdle; OVERRIDE;
		PROCEDURE TTEDocument.DoUpdate; OVERRIDE;
		PROCEDURE TTEDocument.DoCut; OVERRIDE;
		PROCEDURE TTEDocument.DoCopy; OVERRIDE;
		PROCEDURE TTEDocument.DoPaste; OVERRIDE;
		PROCEDURE TTEDocument.DoClear; OVERRIDE;
		FUNCTION TTEDocument.HaveSelection:Boolean; OVERRIDE;
		FUNCTION TTEDocument.CalcIdle:Longint; OVERRIDE;

		{ new public methods }
		PROCEDURE TTEDocument.AdjustScrollValues(mustRedraw:Boolean);
		FUNCTION TTEDocument.GetClickLoop:ProcPtr;
		FUNCTION TTEDocument.GetTEHandle:TEHandle;
		PROCEDURE TTEDocument.GetVisTERgn(rgn:RgnHandle);

		{ methods not intended for use outside of this class }
		PROCEDURE TTEDocument.GetTERect(VAR teRect:Rect);
		PROCEDURE TTEDocument.AdjustTE;
		PROCEDURE TTEDocument.DrawWindow;
		PROCEDURE TTEDocument.AdjustViewRect;
		PROCEDURE TTEDocument.ResizeWindow;
		PROCEDURE TTEDocument.AdjustHV(isVert, mustRedraw:Boolean);
		PROCEDURE TTEDocument.AdjustScrollSizes;
		PROCEDURE TTEDocument.AdjustScrollbars(needsResize:Boolean);
	END;

VAR
	gApplication: TApplication;

IMPLEMENTATION

{$I UTEDocument.inc1.p}

END.
